import React, { useEffect, useRef, useState } from 'react'
import { io } from "socket.io-client"



export default function Socket() {
  const [msg_ar, setMsgAr] = useState([]);
  const socket = io("http://localhost:3001/")
  const inputRef = useRef();

  useEffect(() => {
    socket.on("nodeEvent", onServerListen);
    return () => {
      socket.off("nodeEvent", onServerListen);
    }
  })

  const onServerListen = (_val) => {
    console.log(_val);
    setMsgAr([...msg_ar, _val])
  }

  const onSub = (e) => {
    e.preventDefault();
    console.log(inputRef.current.value);
    socket.emit("clientEvent", inputRef.current.value)
  }

  return (
    <div className="container">
      <h1>Socket React test</h1>
      <form onSubmit={onSub} id="id_form" className="col-md-4 d-flex align-items-center">
        <label>Message:</label>
        <input ref={inputRef} className="form-control" id="id_input" />
        <button className="btn btn-dark">Send</button>
      </form>
      <div className="border col-md-4 mt-3 p-2" style={{ minHeight: "400px" }} id="div_message">
        <div style={{ minHeight: "500px" }} className='border p-2'>
          {msg_ar.map((val,i) => {
            return (
              <h4 key={i}>{val}</h4>
            )
          })}
        </div>
      </div>
    </div>
  )
}
